<template>
  <!-- 列表 -->
  <ContentWrap>
    <el-button
      type="primary"
      plain
      @click="openForm('create')"
      v-hasPermi="['iot:gateway:create']"
    >
      <Icon icon="ep:plus" class="mr-5px" /> 新增
    </el-button>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="设备配置id" align="center" prop="deviceConfigId" />
      <el-table-column label="设备编号" align="center" prop="deviceCode" />
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="设备类型" align="center" prop="deviceType" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_DEVICE_TYPE" :value="scope.row.deviceType" />
        </template>
      </el-table-column>
      <el-table-column label="Siemens系列" align="center" prop="siemensSeries">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_SIEMENS_TYPE" :value="scope.row.siemensSeries" />
        </template>
      </el-table-column>

      <el-table-column label="读取方式" align="center" prop="readCronType">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_1_OR_0" :value="scope.row.readCronType" />
        </template>
      </el-table-column>
      <el-table-column label="读取时间间隔" align="center" prop="readRepeatValue" />
      <el-table-column label="读取时间间隔单位" align="center" prop="readRepeatUnit">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_DEVICE_DATA_UNIT" :value="scope.row.readRepeatUnit" />
        </template>
      </el-table-column>
      <el-table-column label="读取时间表达式" align="center" prop="readCron" />

      <el-table-column label="modbus协议类型" align="center" prop="modbusProtocol">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_MODBUS_TYPE" :value="scope.row.modbusProtocol" />
        </template>
      </el-table-column>

      <el-table-column label="已下发" align="center" prop="isUpload">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_1_OR_0" :value="scope.row.isUpload" />
        </template>
      </el-table-column>
       <el-table-column label="组织设备id" align="center" prop="orgId" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="是否启用" align="center" prop="isEnable" >
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.INFRA_BOOLEAN_STRING" :value="scope.row.isEnable" />
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" fixed="right" width="150">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['iot:gateway:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['iot:gateway:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>
    <!-- 表单弹窗：添加/修改 -->
    <DeviceForm ref="formRef" @success="getList" />
</template>
<script setup lang="ts">
import { DICT_TYPE } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import { GatewayApi } from '@/api/iot/gateway'
import DeviceForm from './DeviceForm.vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const props = defineProps<{
  gatewayId?: number // 网关id（主表的关联字段）
}>()
const loading = ref(false) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  gatewayId: undefined as unknown
})

/** 监听主表的关联字段的变化，加载对应的子表数据 */
watch(
  () => props.gatewayId,
  (val: number) => {
    if (!val) {
      return
    }
    queryParams.gatewayId = val
    handleQuery()
  },
    { immediate: true, deep: true }
)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await GatewayApi.getDevicePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  if (!props.gatewayId) {
    message.error('请选择一个网关')
    return
  }
  formRef.value.open(type, id, props.gatewayId)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await GatewayApi.deleteDevice(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
</script>
